diff --git a/Makefile b/Makefile
index 081a450..b2557ca 100644
--- a/Makefile
+++ b/Makefile
@@ -76,7 +76,11 @@ libx264.a: .depend $(OBJS) $(OBJASM)
 	ranlib libx264.a
 
 $(SONAME): .depend $(OBJS) $(OBJASM)
+ifeq ($(SYS),MACOSX)
+	$(CC) -shared -o $@ $(OBJS) $(OBJASM) -dynamiclib -install_name $(SONAME) $(LDFLAGS)
+else
 	$(CC) -shared -o $@ $(OBJS) $(OBJASM) -Wl,-soname,$(SONAME) $(LDFLAGS)
+endif
 
 x264$(EXE): $(OBJCLI) libx264.a 
 	$(CC) -o $@ $+ $(LDFLAGS)
@@ -156,7 +160,7 @@ install: x264 $(SONAME)
 	install -m 644 x264.pc $(DESTDIR)$(libdir)/pkgconfig
 	install x264 $(DESTDIR)$(bindir)
 	ranlib $(DESTDIR)$(libdir)/libx264.a
-	$(if $(SONAME), ln -sf $(SONAME) $(DESTDIR)$(libdir)/libx264.so)
+	$(if $(SONAME), ln -sf $(SONAME) $(DESTDIR)$(libdir)/libx264.$(SOEXT))
 	$(if $(SONAME), install -m 755 $(SONAME) $(DESTDIR)$(libdir))
 
 install-gtk: libx264gtk.a
@@ -165,7 +169,7 @@ install-gtk: libx264gtk.a
 uninstall:
 	rm -f $(DESTDIR)$(includedir)/x264.h $(DESTDIR)$(libdir)/libx264.a
 	rm -f $(DESTDIR)$(bindir)/x264 $(DESTDIR)$(libdir)/pkgconfig/x264.pc
-	$(if $(SONAME), rm -f $(DESTDIR)$(libdir)/$(SONAME) $(DESTDIR)$(libdir)/libx264.so)
+	$(if $(SONAME), rm -f $(DESTDIR)$(libdir)/$(SONAME) $(DESTDIR)$(libdir)/libx264.$(SOEXT))
 	$(MAKE) -C gtk uninstall
 
 etags: TAGS
diff --git a/configure b/configure
index f54fdda..6ca0734 100755
--- a/configure
+++ b/configure
@@ -459,8 +459,15 @@ cp config.mak gtk/config.mak
 
 if [ "$shared" = "yes" ]; then
     API=$(grep '#define X264_BUILD' < x264.h | cut -f 3 -d ' ')
-    echo "SONAME=libx264.so.$API" >> config.mak
-    echo 'default: $(SONAME)' >> config.mak
+    if [ $SYS = MACOSX ]; then
+        echo "SONAME=libx264.dylib.$API" >> config.mak
+        echo "SOEXT=dylib" >> config.mak
+        echo 'default: $(SONAME)' >> config.mak
+    else
+        echo "SONAME=libx264.so.$API" >> config.mak
+        echo "SOEXT=so" >> config.mak
+        echo 'default: $(SONAME)' >> config.mak
+    fi
     if [ "$gtk" = "yes" ]; then
         echo "SONAMEGTK=libx264gtk.so.$API" >> gtk/config.mak
     fi